print('''
import tensorflow as tf
import matplotlib.pyplot as plt
from sklearn.metrics import classification_report, confusion_matrix,
ConfusionMatrixDisplay
import numpy as np
tf.random.set_seed(42)
num_words = 10000 # Limit the vocabulary to the top 10,000 words
max_length = 100 # Maximum review length (in words)
(x_train, y_train), (x_test, y_test) =
tf.keras.datasets.imdb.load_data(num_words=num_words)
x_train = tf.keras.preprocessing.sequence.pad_sequences(x_train,
maxlen=max_length)
x_test = tf.keras.preprocessing.sequence.pad_sequences(x_test, maxlen=max_length)
model = tf.keras.Sequential([ tf.keras.layers.Embedding(input_dim=num_words,
output_dim=32, input_length=max_length), tf.keras.layers.LSTM(32, dropout=0.2,
recurrent_dropout=0.2), tf.keras.layers.Dense(1, activation='sigmoid') ])
model.compile(loss='binary_crossentropy', optimizer='adam', metrics=['accuracy'])
history = model.fit(x_train, y_train, validation_split=0.2, epochs=5, batch_size=128)
test_loss, test_acc = model.evaluate(x_test, y_test) print(f"\nTest Accuracy:
{test_acc:.4f}")
y_pred_prob = model.predict(x_test) y_pred = (y_pred_prob > 0.5).astype(int)
print("\nClassification Report:") print(classification_report(y_test, y_pred,
target_names=["Negative", "Positive"]))
cm = confusion_matrix(y_test, y_pred) disp =
ConfusionMatrixDisplay(confusion_matrix=cm,
display_labels=["Negative", "Positive"])
disp.plot(cmap='Blues')
plt.title("Confusion Matrix")
plt.show()
plt.figure(figsize=(12, 5))
plt.subplot(1, 2, 1)
plt.plot(history.history['accuracy'], label="Train Acc")
plt.plot(history.history['val_accuracy'], label="Val Acc")
plt.title("Accuracy over Epochs")
plt.xlabel("Epoch")
plt.ylabel("Accuracy")
plt.legend()
plt.subplot(1, 2, 2)
plt.plot(history.history['loss'], label="Train Loss")
plt.plot(history.history['val_loss'], label="Val Loss") plt.title("Loss over Epochs")
plt.xlabel("Epoch")
plt.ylabel("Loss") plt.legend()
plt.tight_layout() plt.show()

      ''')
